#declare hill_texture=
// texture { pigment { color rgb <0.4,0.55,0.55> }}
 texture { pigment { color rgb <0.80,0.40,0.45> }}

#declare vegetation =
texture {
pigment {
//agate
wrinkles
octaves 3
omega 0.7
lambda 10
turbulence .5
color_map {
[ 0.0 color rgb < 0.2, 0.2, 0.1> ]
[ 0.6 color rgb < 0.7, 0.9, 0.6> ]
[ 0.9 color rgb < 0.4, 0.9, 0.5> ]
} // end color map

}  // end pigment
scale < .003, 003, .003 >
finish { ambient 0.1 }
normal { bumps 1 scale 0.001 }
} // end texture
  
// land elements
  
#declare iso1=
 isosurface {
 function {
 //y-f_noise3d(x,0,z) 
 y-(z/7)-f_wrinkles  (x,0,z) 
 }
 max_gradient 2.5 
 // open
 contained_by  { box { <-5,-1,-2>, <5,2,2>  } }
}

#declare iso2=
 isosurface {
 function {
 //y-f_agate  (x,0,z)
 y-f_granite  (x,0,z)
 } 
 open
 contained_by  { box { <-5,-1,-2>, <5,1,2>  } }
}    

#declare iso3=
 isosurface {
 function {
 //y-f_agate  (x,y,z)
 y-(f_granite  (x*5,y,z*5) * f_noise3d(x,y,z) )
 //y-f_granite  (x*5,y,z*5) 
 } 
 open
 contained_by  { box { <-5,-1,-.4>, <5,1,.4>  } }
}
#declare iso4=
 isosurface {
 function {
 y-f_noise3d(x*60,0,z*60)*0.1
// -f_noise3d(5*x,0,5*z)*0.3
 -f_crackle(3*x,0,3*z)*0.3
 } 
 max_gradient 2
 open
 contained_by  { box { <-2,-1,-1>, <2,1,1>  } }
}
#if (forground>0)
 #if (far_vegetation>0)
  object { 
   iso1
   scale <2,1,2> 
   translate  <0,-0.3,0>
   texture {vegetation} 
  }
 #end
 object { 
  iso1
  scale <2.2,0.95,2.2> 
  translate  <0,-0.25,0>
  texture { pigment { color rgb <0.4,0.55,0.55> }}
 }
 object { 
  iso2
  scale <2.2,0.7,2.2> 
  translate  <0,-0.25,0>
  texture { pigment { color rgb <0.4,0.55,0.55> }}
 } 
#end

#if (middle_land>0)

object { 
 iso1  
 //no_shadow
 scale <10,6,10> 
 translate  <0,-3,1500>
 texture { hill_texture }
 finish { ambient 0.04 } //
}

#if (far_vegetation>0)
 object { 
  iso3  
  no_shadow
  //scale <80,140,80>  
  //scale <80,60,80>
  scale <80,60,80>  
  // rotate 20*x
  translate  <0,-10,2500>
 texture {vegetation}
 }


 object { 
  iso4  
  //no_shadow
  rotate -0*x
  scale <80,160,80>  
  translate  <-100,-30,1500>
  texture { pigment { color rgb <0.2,0.55,0.2> }}
 } 
 
#end // far vegetation

#end // middle land


#if (middle_hills>0)
object { 
 iso1 
 //no_shadow
 scale <22,12,22>*20 
 translate  <0,-100.,3000>
 texture { hill_texture }
 finish { ambient 0.05 } //
}
#end                          
